diff --git a/packages/visualgst/Implementors/GtkSenderResultsWidget.st b/packages/visualgst/Implementors/GtkSenderResultsWidget.st
index 41d817f..b081c96 100644
--- a/packages/visualgst/Implementors/GtkSenderResultsWidget.st
+++ b/packages/visualgst/Implementors/GtkSenderResultsWidget.st
@@ -55,10 +55,8 @@ GtkImageResultsWidget subclass: GtkSenderResultsWidget [
     buildTreeView [
         <category: 'user interface'>
 
-	| widget |
-	widget := super buildTreeView.
-	model contentsBlock: [ :each | {each displayString} ].
-	^ widget
+	super buildTreeView.
+	widget contents: [ :each | {each displayString} ].
     ]
 
     appendSenderResults: aDictionary [
@@ -77,8 +75,9 @@ GtkImageResultsWidget subclass: GtkSenderResultsWidget [
     findInMethod: anObject [
         <category: 'find'>
 
-        (self literalsAndSpecialSelectors at: anObject displaySymbol ifAbsent: [ #() ] ) do: [ :each |
-            model append: each ].
+        widget 
+            item: (self literalsAndSpecialSelectors at: anObject displaySymbol ifAbsent: [ #() ] ) asArray;
+            refresh
     ]
 
     selectedResult: aBrowser [
diff --git a/packages/visualgst/Inspector/GtkInspector.st b/packages/visualgst/Inspector/GtkInspector.st
index b223372..3d864cc 100644
--- a/packages/visualgst/Inspector/GtkInspector.st
+++ b/packages/visualgst/Inspector/GtkInspector.st
@@ -86,25 +86,18 @@ GtkBrowsingTool subclass: GtkInspector [
     buildCentralWidget [
 	<category: 'intialize-release'>
 
-	| trWidget wkWidget |
-	notebookWidget := GTK.GtkNotebook new.
-	trWidget := self buildInspectorView.
-	wkWidget := self buildBrowserWidget mainWidget.
+	notebookWidget := Notebook new.
 	^ notebookWidget
-	    appendPage: trWidget tabLabel: (GTK.GtkLabel new: 'Basic');
-	    appendPage: wkWidget tabLabel: (GTK.GtkLabel new: 'Methods');
-	    showAll;
-	    setCurrentPage: 0;
-	    yourself
+	    addPermanentWidget: self buildInspectorView label: 'Basic';
+	    addPermanentWidget: self buildBrowserWidget label: 'Methods';
+	    currentPage: 0;
+            yourself
     ]
 
     buildInspectorView [
 	<category: 'user interface'>
 
-	^ GTK.GtkVPaned new
-            pack1: self buildInspectorWidget mainWidget resize: true shrink: false;
-            pack2: self buildWorkspaceWidget mainWidget resize: false shrink: true;
-            yourself
+	^ VPaned with: self buildInspectorWidget with: self buildWorkspaceWidget
     ]
 
     buildInspectorWidget [
@@ -112,9 +105,7 @@ GtkBrowsingTool subclass: GtkInspector [
 
 	^ inspectorWidget := (GtkInspectorWidget new)
 				parentWindow: window;
-				initialize;
 				inspector: self;
-				showAll;
 				yourself
     ]
 
@@ -123,8 +114,6 @@ GtkBrowsingTool subclass: GtkInspector [
 
 	^ workspaceWidget := (GtkInspectorSourceWidget new)
 				parentWindow: window;
-				initialize;
-				showAll;
 				yourself
     ]
 
@@ -133,8 +122,6 @@ GtkBrowsingTool subclass: GtkInspector [
 
 	^ browserWidget := (GtkInspectorBrowserWidget new)
 				parentWindow: window;
-				initialize;
-				showAll;
 				yourself
     ]
 
@@ -151,7 +138,7 @@ GtkBrowsingTool subclass: GtkInspector [
     focusedWidget [
         <category: 'focus'>
 
-        ^notebookWidget getCurrentPage = 0
+        ^ notebookWidget currentPage = 0
             ifTrue: [ workspaceWidget focusedWidget ]
             ifFalse: [ browserWidget focusedWidget ]
     ]
@@ -286,7 +273,7 @@ GtkBrowsingTool subclass: GtkInspector [
     browserHasFocus [
         <category: 'command protocols'>
 
-        ^notebookWidget getCurrentPage = 1
+        ^ notebookWidget currentPage = 1
     ]
 
     sourceCodeWidgetHasFocus [
diff --git a/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st b/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st
index 599cee3..98eb66a 100644
--- a/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st
+++ b/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st
@@ -33,7 +33,8 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkInspectorBrowserWidget [
+Compoment subclass: GtkInspectorBrowserWidget [
+
     | checkCode namespaceWidget classHierarchyWidget classHierarchyUpdate iCategoryWidget iMethodWidget cCategoryWidget cMethodWidget codeWidget state |
 
     GtkInspectorBrowserWidget class >> title [
@@ -50,69 +51,59 @@ GtkConcreteWidget subclass: GtkInspectorBrowserWidget [
 
     buildBrowser [
 
-	^ GTK.GtkHPaned addAll: {self buildHierarchy. self buildProtocolAndMethod}
+	^ HPaned addAll: {self buildHierarchy. self buildProtocolAndMethod}
     ]
 
     buildClassBrowser [
 
-	^ GTK.GtkHPaned addAll: {self buildClassMethodView}
+	^ HPaned addAll: {self buildClassMethodView}
     ]
 
     buildInstanceBrowser [
 
-	^ GTK.GtkHPaned addAll: {self buildInstanceMethodView}
+	^ HPaned addAll: {self buildInstanceMethodView}
     ]
 
     buildProtocolAndMethod [
 
-	^  (GTK.GtkNotebook new)
-	    appendPage: self buildInstanceBrowser tabLabel: (GTK.GtkLabel new: 'Instance');
-	    appendPage: self buildClassBrowser tabLabel: (GTK.GtkLabel new: 'Class');
-	    showAll;
-	    setCurrentPage: 0;
-	    connectSignal: 'switch-page' to: self selector: #'classInstanceSwitchOn:page:number:' userData: nil;
+	^  Notebook new
+	    addPermanentWidget: self buildInstanceBrowser label: 'Instance';
+	    addPermanentWidget: self buildClassBrowser label: 'Class';
+	    currentPage: 0;
+	    "connectSignal: 'switch-page' to: self selector: #'classInstanceSwitchOn:page:number:' userData: nil;"
 	    yourself
     ]
 
     buildCodeView [
 	<category: 'user interface'>
 
-	codeWidget := (GtkSourceCodeWidget parentWindow: self parentWindow)
+	^ codeWidget := (GtkSourceCodeWidget parentWindow: self parentWindow)
 			browser: self;
-			showAll;
 			yourself.
-    
-	^ codeWidget mainWidget
     ]
 
     buildHierarchy [
 	<category: 'user interface'>
 
-	classHierarchyWidget := GtkClassHierarchyWidget showAll
+	^ classHierarchyWidget := GtkClassHierarchyWidget new
 				    whenSelectionChangedSend: #onClassHierarchyChanged to: self;
 				    yourself.
-
-	^ classHierarchyWidget mainWidget
     ]
 
     buildClassMethodView [
 	<category: 'user interface'>
 
-	cMethodWidget := GtkMethodWidget showAll
+	^ cMethodWidget := GtkMethodWidget new
 			    whenSelectionChangedSend: #onClassSideMethodChanged to: self;
 			    yourself.
-
-	^ cMethodWidget mainWidget
     ]
 
     buildInstanceMethodView [
         <category: 'user interface'>
 
-        iMethodWidget := GtkMethodWidget showAll 
+        ^ iMethodWidget := GtkMethodWidget new
                             whenSelectionChangedSend: #onInstanceSideMethodChanged to: self;
                             yourself.
-
-        ^ iMethodWidget mainWidget
     ]
 
     initialize [
@@ -121,7 +112,7 @@ GtkConcreteWidget subclass: GtkInspectorBrowserWidget [
 	classHierarchyUpdate := false.
 	checkCode := true.
 	state := NamespaceState on: self with: Smalltalk.
-	self mainWidget: (GTK.GtkVPaned addAll: {self buildBrowser. self buildCodeView})
+	self widget: (VPaned addAll: {self buildBrowser. self buildCodeView})
     ]
 
     classInstanceSwitchOn: aGtkNotebook page: aGtkNotebookPage number: aSmallInteger [
diff --git a/packages/visualgst/Inspector/GtkInspectorWidget.st b/packages/visualgst/Inspector/GtkInspectorWidget.st
index 843b4bc..74f5342 100644
--- a/packages/visualgst/Inspector/GtkInspectorWidget.st
+++ b/packages/visualgst/Inspector/GtkInspectorWidget.st
@@ -33,14 +33,14 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkInspectorWidget [
-    | inspector model object inspectorTree workspaceWidget objectView stack |
+Compoment subclass: GtkInspectorWidget [
+
+    | inspector object inspectorTree workspaceWidget objectView stack |
 
     GtkInspectorWidget >> openOn: anObject [
 	<category: 'instance creation'>
 
-	^ (super new)
-	    initialize;
+	^ self new
 	    object: anObject;
 	    yourself
     ]
@@ -49,8 +49,8 @@ GtkConcreteWidget subclass: GtkInspectorWidget [
 	<category: 'initialization'>
 
 	stack := OrderedCollection new.
-	self mainWidget: self buildView.
-	self whenSelectionChangedSend: #onVariableChanged to: self.
+	self buildView.
+	inspectorTree whenSelectionChangedSend: #onVariableChanged to: self.
     ]
 
     postInitialize [
@@ -78,7 +78,7 @@ GtkConcreteWidget subclass: GtkInspectorWidget [
 	objectView := object inspectorView openOn: anObject.
 	workspaceWidget object: anObject.
 	inspector isNil ifFalse: [ inspector object: anObject ].
-	model 
+	inspectorTree 
 	    item: objectView;
 	    refresh
     ]
@@ -86,11 +86,9 @@ GtkConcreteWidget subclass: GtkInspectorWidget [
     buildTreeWidget [
 	<category: 'user interface'>
 
-        inspectorTree := GtkScrollTreeWidget createListWithModel: {{GtkColumnTextType title: 'Variables'}}.
-        inspectorTree connectToWhenPopupMenu: (InspectorMenus on: self).
-        (model := GtkListModel on: inspectorTree treeView getModel)
-                                        contentsBlock: [ :each | {each displayString} ].
-        ^ inspectorTree mainWidget
+        inspectorTree := List column: {{GtkColumnTextType title: 'Variables'}} contents: [ :each | {each displayString} ].
+        inspectorTree popupMenu: (InspectorMenus on: self).
+        ^ inspectorTree
     ]
 
     buildWorkspaceWidget [
@@ -105,23 +103,13 @@ GtkConcreteWidget subclass: GtkInspectorWidget [
     buildView [
         <category: 'user interface'>
    
-	^ GTK.GtkHPaned new
-	    pack1: self buildTreeWidget resize: true shrink: false;
-            pack2: self buildWorkspaceWidget mainWidget resize: true shrink: false;
-            yourself
-    ]
-
-    whenSelectionChangedSend: aSelector to: anObject [
-        <category: 'events'>
-
-        inspectorTree treeView getSelection
-            connectSignal: 'changed' to: anObject selector: aSelector userData: nil
+	self widget: (HPaned with: self buildTreeWidget with: self buildWorkspaceWidget)
     ]
 
     hasSelectedValue [
         <category: 'testing'>
 
-        ^ inspectorTree treeView hasSelectedItem 
+        ^ inspectorTree hasSelection
     ]
 
     onVariableChanged [
@@ -135,7 +123,7 @@ GtkConcreteWidget subclass: GtkInspectorWidget [
 	<category: 'item selection'>
 
         self hasSelectedValue ifFalse: [ self error: 'Nothing is selected' ].
-        ^ inspectorTree treeView selection
+        ^ inspectorTree selection
     ]
 
     targetObject [
diff --git a/packages/visualgst/Inspector/View/GtkCharacterInspectorView.st b/packages/visualgst/Inspector/View/GtkCharacterInspectorView.st
new file mode 100644
index 0000000..cc313e9
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkCharacterInspectorView.st
@@ -0,0 +1,62 @@
+"======================================================================
+|
+| GtkCharacterInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkCharacterInspectorView [
+
+    do: aBlock [
+	super do: aBlock.
+        #('hexadecimal' 'octal' 'binary') do: aBlock
+    ]
+
+    selectedValue: aString [
+	<category: 'events'>
+
+	| base |
+	base := 0.
+	aString = 'hexadecimal' ifTrue: [ base := 16 ].
+	aString = 'octal' ifTrue: [ base := 8 ].
+	aString = 'binary' ifTrue: [ base := 2 ].
+	^ base = 0 
+	    ifTrue: [ super selectedValue: aString ]
+	    ifFalse: [ self object asInteger printString: base ]
+    ]
+
+    canDive [
+        <category: 'testing'>
+
+        ^ false
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkCompiledBlockInspectorView.st b/packages/visualgst/Inspector/View/GtkCompiledBlockInspectorView.st
new file mode 100644
index 0000000..2cee85c
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkCompiledBlockInspectorView.st
@@ -0,0 +1,124 @@
+"======================================================================
+|
+| GtkCompiledBlockINspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkCompiledBlockInspectorView [
+
+    GtkCompiledBlockInspectorView class [ | fields | ]
+
+    GtkCompiledBlockInspectorView class >> fields [
+	<category: 'accessing'>
+
+	^ fields ifNil: [ fields := Dictionary from: {'clean-ness flags'->#flags. 
+					    'Number Of Arguments'->#arguments.
+					    'Number Of Temporaries'->#temporaries.
+					    'Number Of Literals'->#numLiterals.
+					    'Needed Stack Slots'->#stack.
+					    'Byte Codes'->#byte.
+					    'Source Code'->#source} ]
+    ]
+
+    do: aBlock [
+	<category: 'accessing'>
+
+	super do: aBlock.
+        self class fields keys do: aBlock
+    ]
+
+    selectedValue: anObject [
+	<category: 'events'>
+
+        ^ (self class fields includesKey: anObject)
+	    ifFalse: [ super selectedValue: anObject ]
+            ifTrue: [ self perform: (self class fields at: anObject) ]
+    ]
+
+    flags [
+	<category: 'event'>
+
+	^ self object flags
+    ]
+
+    arguments [
+	<category: 'event'>
+
+	^ self object numArgs 
+    ]
+
+    temporaries [
+	<category: 'event'>
+
+	^ self object numTemps
+    ]
+
+    numLiterals [
+	<category: 'event'>
+
+	^ self object numLiterals
+    ]
+
+    stack [
+	<category: 'event'>
+
+	^ self object stackDepth
+    ]
+
+    literals [
+	<category: 'event'>
+
+	| stream |
+	stream := WriteStream on: String new.
+	1 to: self numLiterals do: [ :i | 
+		self object bytecodeIndex: i with: stream. 
+		stream tab. 
+		stream print: (self object literalAt: i) ].
+	^ stream contents
+    ]
+
+    byte [
+	<category: 'event'>
+
+	| stream |
+	stream := WriteStream on: String new.
+	self object numBytecodes > 0 ifTrue: [ self object printByteCodesOn: stream ].
+	^ stream contents
+    ]
+
+    source [
+	<category: 'event'>
+
+	^ self object methodSourceString
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkCompiledMethodInspectorView.st b/packages/visualgst/Inspector/View/GtkCompiledMethodInspectorView.st
new file mode 100644
index 0000000..acfaefd
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkCompiledMethodInspectorView.st
@@ -0,0 +1,133 @@
+"======================================================================
+|
+| GtkCompiledMethodInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkCompiledMethodInspectorView [
+
+    GtkCompiledMethodInspectorView class [ | fields | ]
+
+    GtkCompiledMethodInspectorView class >> fields [
+	<category: 'accessing'>
+
+	^ fields ifNil: [ fields := Dictionary from: {'Flags'->#flags. 
+					    'Primitive Index'->#primitive.
+					    'Number Of Arguments'->#arguments.
+					    'Number Of Temporaries'->#temporaries.
+					    'Number Of Literals'->#numLiterals.
+					    'Needed Stack Slots'->#stack.
+					    'Literals'->#literals.
+					    'Byte Codes'->#byte.
+					    'Source Code'->#source} ]
+    ]
+
+    do: aBlock [
+	<category: 'accessing'>
+
+	super do: aBlock.
+        self class fields keys do: aBlock
+    ]
+
+    selectedValue: anObject [
+	<category: 'events'>
+
+        ^ (self class fields includesKey: anObject)
+	    ifFalse: [ super selectedValue: anObject ]
+            ifTrue: [ self perform: (self class fields at: anObject) ]
+    ]
+
+    flags [
+	<category: 'event'>
+
+	^ self object flags
+    ]
+
+    primitive [
+	<category: 'event'>
+
+	self object flags = 4 ifTrue: [ VMPrimitives keyAtValue: self object primitive ifAbsent: [ 'unknown' ] ].
+	^ self object primitive 
+    ]
+
+    arguments [
+	<category: 'event'>
+
+	^ self object numArgs 
+    ]
+
+    temporaries [
+	<category: 'event'>
+
+	^ self object numTemps
+    ]
+
+    numLiterals [
+	<category: 'event'>
+
+	^ self object numLiterals
+    ]
+
+    stack [
+	<category: 'event'>
+
+	^ self object stackDepth
+    ]
+
+    literals [
+	<category: 'event'>
+
+	| stream |
+	stream := WriteStream on: String new.
+	1 to: self numLiterals do: [ :i | 
+		self object bytecodeIndex: i with: stream. 
+		stream tab. 
+		stream print: (self object literalAt: i) ].
+	^ stream contents
+    ]
+
+    byte [
+	<category: 'event'>
+
+	| stream |
+	stream := WriteStream on: String new.
+	self object numBytecodes > 0 ifTrue: [ self object printByteCodesOn: stream ].
+	^ stream contents
+    ]
+
+    source [
+	<category: 'event'>
+
+	^ self object methodSourceString
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkContextInspectorView.st b/packages/visualgst/Inspector/View/GtkContextInspectorView.st
new file mode 100644
index 0000000..46ab341
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkContextInspectorView.st
@@ -0,0 +1,58 @@
+"======================================================================
+|
+| GtkContextInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkContextInspectorView [
+
+    | args temps |
+
+    do: aBlock [
+        <category: 'iterating'>
+
+        args := IdentitySet new.
+        temps := IdentitySet new.
+        super do: aBlock.
+        self object method arguments do: [ :each | aBlock value: (args add: each asString) ].
+        self object method temporaries do: [ :each | aBlock value: (temps add: each asString) ].
+    ]
+
+    selectedValue: aString [
+        <category: 'events'>
+
+        ((args includes: aString) not and: [ (temps includes: aString) not ]) ifTrue: [ ^ super selectedValue: aString ].
+        (args includes: aString) ifTrue: [ ^ (self object at: (self object method arguments indexOf: aString asSymbol)) displayString ].
+        ^ (self object at: self object numArgs + (self object method temporaries indexOf: aString asSymbol)) displayString.
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkDictionaryInspectorView.st b/packages/visualgst/Inspector/View/GtkDictionaryInspectorView.st
new file mode 100644
index 0000000..89d7a57
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkDictionaryInspectorView.st
@@ -0,0 +1,53 @@
+"======================================================================
+|
+| GtkDictionaryInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkDictionaryInspectorView [
+
+    do: aBlock [
+	<category: 'accessing'>
+
+	super do: aBlock.
+        self object keys do: aBlock
+    ]
+
+    selectedValue: anObject [
+        <category: 'events'>
+
+        ^ (self object includesKey: anObject)
+            ifFalse: [ super selectedValue: anObject ]
+            ifTrue: [ self object at: anObject ]
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkFloatInspectorView.st b/packages/visualgst/Inspector/View/GtkFloatInspectorView.st
new file mode 100644
index 0000000..5b36ce0
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkFloatInspectorView.st
@@ -0,0 +1,51 @@
+"======================================================================
+|
+| GtkFloatInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkFloatInspectorView [
+
+    do: aBlock [
+	super do: aBlock.
+	1 to: self object size do: [ :each | aBlock value: each ]
+    ]
+
+    selectedValue: aString [
+	<category: 'events'>
+
+        ^ aString asNumber = 0
+            ifTrue: [  super onVariableChanged ]
+            ifFalse: [ self object at: aString asNumber ]
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkIntegerInspectorView.st b/packages/visualgst/Inspector/View/GtkIntegerInspectorView.st
new file mode 100644
index 0000000..f008f3f
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkIntegerInspectorView.st
@@ -0,0 +1,62 @@
+"======================================================================
+|
+| GtkInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkIntegerInspectorView [
+
+    do: aBlock [
+	super do: aBlock.
+        #('hexadecimal' 'octal' 'binary') do: aBlock
+    ]
+
+    selectedValue: aString [
+        <category: 'item selection'>
+
+        | base iter string instVar |
+	base := 0.
+        aString = 'hexadecimal' ifTrue: [ base := 16 ].
+        aString = 'octal' ifTrue: [ base := 8 ].
+        aString = 'binary' ifTrue: [ base := 2 ].
+        ^ base = 0 
+	    ifTrue: [ super selectedValue: aString ]
+	    ifFalse: [ self object printString: base ]
+    ]
+
+    canDive [
+        <category: 'testing'>
+
+        ^ false
+    ]
+]
+
